您的位置:首页 > 运维架构

Hdu 1299 Diophantus of Alexandria

2013-03-23 16:12 369 查看
 

Diophantus of Alexandria

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 1749    Accepted Submission(s): 658


[align=left]Problem Description[/align]
Diophantus of Alexandria was an egypt mathematician living in Alexandria. He was one of the first mathematicians to study equations where variables were restricted to integral values. In honor of him, these equations are commonly
called diophantine equations. One of the most famous diophantine equation is x^n + y^n = z^n. Fermat suggested that for n > 2, there are no solutions with positive integral values for x, y and z. A proof of this theorem (called Fermat's last theorem) was found
only recently by Andrew Wiles.

Consider the following diophantine equation:

1 / x + 1 / y = 1 / n where x, y, n ∈ N+ (1)

Diophantus is interested in the following question: for a given n, how many distinct solutions (i. e., solutions satisfying x ≤ y) does equation (1) have? For example, for n = 4, there are exactly three distinct solutions:

1 / 5 + 1 / 20 = 1 / 4

1 / 6 + 1 / 12 = 1 / 4

1 / 8 + 1 / 8 = 1 / 4

Clearly, enumerating these solutions can become tedious for bigger values of n. Can you help Diophantus compute the number of distinct solutions for big values of n quickly?

 

 

[align=left]Input[/align]
The first line contains the number of scenarios. Each scenario consists of one line containing a single number n (1 ≤ n ≤ 10^9).

 

 

[align=left]Output[/align]
The output for every scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1. Next, print a single line with the number of distinct solutions of equation (1) for the given value of
n. Terminate each scenario with a blank line.

 

 

[align=left]Sample Input[/align]

2
4
1260

 

 

[align=left]Sample Output[/align]

Scenario #1:
3

Scenario #2:
113

 

 

[align=left]Source[/align]
TUD Programming Contest 2006
 

 

[align=left]Recommend[/align]
JGShining
 
题目链接
 
解题思路:
n/1=1/(n+k)+k/(n*(n+k))=1/(n+k)+1/(n^2+n*k)/k=1/(n+k)+1/(n^2/k+n);
 
由于a=n+k<2*n(如果等于2n那么就是a==b了) 得到 k<n,而显然k是n^2的因子
 
方法:质数打表+DFS

 
 
#include<stdio.h>

__int64 pri[1000011];
bool num[1000011];

struct Node{
__int64 x;
int cent;
}map[1000];
int d[1000];
__int64 s,n,count;

void Is_prime()
{
__int64 i,j;
pri[0]=0;
for(i=2;i<=1000000;i++)
{
if(!num[i])
{
pri[++pri[0]]=i;
for(j=i*i;j<=1000000;j+=i)
num[j]=1;
}
}
}

void DFS(__int64 tmp,int x)
{
int i;
for(i=x;i<=count;i++)
{
if(map[i].cent>0 && tmp*map[i].x<=n)
{
s++;
map[i].cent--;
DFS(tmp*map[i].x,i);
map[i].cent++;
}
else if(tmp*map[i].x>n)
return ;

}
}

int main()
{
int T,t=1;
__int64 i,tmp,m;

Is_prime();

scanf("%d",&T);

while(t<=T)
{
scanf("%I64d",&n);
printf("Scenario #%d:\n",t);

count=0;
tmp=n;
for(i=1;pri[i]<=tmp && i<=pri[0];i++)
{
if(tmp%pri[i]==0)
{
map[++count].x=pri[i];
map[count].cent=0;
while(!(tmp%pri[i]))
{
map[count].cent+=2;
tmp/=pri[i];
}
}
}
if(tmp!=1)
{
map[++count].x=tmp;
map[count].cent=2;
}

s=0;
for(i=1;i<=count;i++)
{
if(map[i].x<=n)
{
s++;
map[i].cent--;
DFS(map[i].x,i);
map[i].cent++;
}
else
break;
}

printf("%I64d\n\n",++s);
t++;
}
return 0;
}


 
 
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: